using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using GroupLab.Networking;

namespace SimpleFileTransfer
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private GroupLab.Networking.SharedDictionary sharedDictionary1;
		private GroupLab.Networking.Subscription subscription1;
		private System.Windows.Forms.Button uploadButton;
		private System.Windows.Forms.Button downloadButton;
		private System.Windows.Forms.OpenFileDialog openFileDialog1;
		private System.Windows.Forms.SaveFileDialog saveFileDialog1;
		private System.Windows.Forms.Label label1;
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.ProgressBar progressBar1;
		private System.Windows.Forms.Label label2;
		private FileTransfer ft;
		private System.Windows.Forms.Button pauseButton;
		private System.Windows.Forms.Button resumeButton;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			// set the URL of Shared Dictionary
			this.sharedDictionary1.Url = "tcp://localhost:test";
			// open the connection
			this.sharedDictionary1.Open();

			// signal begining of initialization for subscription1
			this.subscription1.BeginInit();	
			// register the pattern with the shared dictionary server (everything in this case)
			this.subscription1.Pattern = "*"; 
			// register the event handler
			this.subscription1.Notified += new SubscriptionEventHandler(subscription1_Notified); 
			// signal the end of initialization
			this.subscription1.EndInit(); 

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.sharedDictionary1 = new GroupLab.Networking.SharedDictionary(this.components);
			this.subscription1 = new GroupLab.Networking.Subscription(this.components);
			this.uploadButton = new System.Windows.Forms.Button();
			this.downloadButton = new System.Windows.Forms.Button();
			this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
			this.saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
			this.label1 = new System.Windows.Forms.Label();
			this.pauseButton = new System.Windows.Forms.Button();
			this.resumeButton = new System.Windows.Forms.Button();
			this.progressBar1 = new System.Windows.Forms.ProgressBar();
			this.label2 = new System.Windows.Forms.Label();
			((System.ComponentModel.ISupportInitialize)(this.subscription1)).BeginInit();
			this.SuspendLayout();
			// 
			// sharedDictionary1
			// 
			this.sharedDictionary1.SynchronizingObject = this;
			// 
			// subscription1
			// 
			this.subscription1.Dictionary = this.sharedDictionary1;
			// 
			// uploadButton
			// 
			this.uploadButton.Location = new System.Drawing.Point(272, 16);
			this.uploadButton.Name = "uploadButton";
			this.uploadButton.Size = new System.Drawing.Size(72, 24);
			this.uploadButton.TabIndex = 0;
			this.uploadButton.Text = "Upload";
			this.uploadButton.Click += new System.EventHandler(this.uploadButton_Click);
			// 
			// downloadButton
			// 
			this.downloadButton.Location = new System.Drawing.Point(272, 48);
			this.downloadButton.Name = "downloadButton";
			this.downloadButton.Size = new System.Drawing.Size(72, 24);
			this.downloadButton.TabIndex = 1;
			this.downloadButton.Text = "Download";
			this.downloadButton.Click += new System.EventHandler(this.downloadButton_Click);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(16, 16);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(240, 88);
			this.label1.TabIndex = 2;
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// pauseButton
			// 
			this.pauseButton.Location = new System.Drawing.Point(272, 96);
			this.pauseButton.Name = "pauseButton";
			this.pauseButton.Size = new System.Drawing.Size(72, 24);
			this.pauseButton.TabIndex = 3;
			this.pauseButton.Text = "Pause";
			this.pauseButton.Click += new System.EventHandler(this.pauseButton_Click);
			// 
			// resumeButton
			// 
			this.resumeButton.Location = new System.Drawing.Point(272, 128);
			this.resumeButton.Name = "resumeButton";
			this.resumeButton.Size = new System.Drawing.Size(72, 24);
			this.resumeButton.TabIndex = 4;
			this.resumeButton.Text = "Resume";
			this.resumeButton.Click += new System.EventHandler(this.resumeButton_Click);
			// 
			// progressBar1
			// 
			this.progressBar1.Location = new System.Drawing.Point(8, 168);
			this.progressBar1.Name = "progressBar1";
			this.progressBar1.Size = new System.Drawing.Size(336, 24);
			this.progressBar1.TabIndex = 6;
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 136);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(240, 24);
			this.label2.TabIndex = 7;
			this.label2.Text = "Bytes: ";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(360, 198);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.progressBar1);
			this.Controls.Add(this.resumeButton);
			this.Controls.Add(this.pauseButton);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.downloadButton);
			this.Controls.Add(this.uploadButton);
			this.Name = "Form1";
			this.Text = "Form1";
			((System.ComponentModel.ISupportInitialize)(this.subscription1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void uploadButton_Click(object sender, System.EventArgs e)
		{
			if(this.openFileDialog1.ShowDialog(this) == DialogResult.OK)
			{
				ft = new FileTransfer(this.openFileDialog1.FileName);
				this.sharedDictionary1[ft.Id.ToString()] = ft;
				this.label1.Text = this.openFileDialog1.FileName;
			}
		}

		private void downloadButton_Click(object sender, System.EventArgs e)
		{
			this.saveFileDialog1.FileName = this.label1.Text;
			if(this.saveFileDialog1.ShowDialog(this) == DialogResult.OK)
			{
				ft.SaveAs(this.saveFileDialog1.FileName);
			}

		}

		private void subscription1_Notified(object sender, SubscriptionEventArgs e)
		{
			ft = e.Value as FileTransfer;
			this.label1.Text = ft.FileName;
			ft.Progress += new EventHandler(ft_Progress);
		}

		private void pauseButton_Click(object sender, System.EventArgs e) 
		{
			if(ft.Status == FileTransferStatus.Transferring) 
			{
				ft.Pause();
			}

		}

		private void resumeButton_Click(object sender, System.EventArgs e)
		{
			if(ft.Status == FileTransferStatus.Paused)
			{
				ft.Resume();
			}
		}

		private void ft_Progress(object sender, EventArgs e)
		{
			ft = sender as FileTransfer;

			// update progress bar
			this.progressBar1.Maximum = ft.Length;
			this.progressBar1.Value = ft.BytesTransferred;

			// show bytes transfered
			this.label2.Text = "Bytes: " + ft.BytesTransferred.ToString();
			if (this.progressBar1.Value == ft.Length)
				this.label2.Text += "    Finished";		
		}

	}
}
